package com.nationwide.thi.jclaims.shared;
 
import org.acegisecurity.Authentication;
import org.acegisecurity.context.SecurityContextHolder;

import com.nationwide.thi.jclaims.shared.db.JdbcUtils;
import com.nationwide.thi.jclaims.web.menubuilder.SubMenuBuilderFacade;
import com.nationwide.thi.jclaims.web.menubuilder.SubMenuReader;
import com.nationwide.thi.jclaims.web.menubuilder.TabSetsReader;

public final class AppRegistry {
	private static AppRegistry appRegistry;
    private  JdbcUtils jdbcUtils;
    private  FileIoUtilsOperations fileIoUtils;
//    private  ConnectionManager connectionManager;
    private  TabSetsReader tabSetsReader;
	private  SubMenuReader subMenuReader;	
	private  SubMenuBuilderFacade subMenuBuilder;
	private  XMLValidator xmlValidator;

	// TODO: in light of http://tech.puredanger.com/2007/06/15/double-checked-locking/,
	//       we're probably doing this the wrong way, and may even be opening ourselves for some
	//       chances for NullPointerException...shall we change it?
	public static synchronized AppRegistry getInstance(){
		if(null == appRegistry){
			appRegistry = new AppRegistry(); 
		}
		return appRegistry;
	}
	
	protected AppRegistry(){
	}
	
    public JdbcUtils getJdbcUtils() {
        if (null == jdbcUtils) {
            jdbcUtils = new JdbcUtils();
        }

        return jdbcUtils;
    }

    public FileIoUtilsOperations getFileIoUtils() {
        if (null == fileIoUtils) {
            fileIoUtils = new FileIoUtils();
        }

        return fileIoUtils;
    }

//    public ConnectionManager getConnectionManager() {
//        return connectionManager;
//    }
    
//    public void setConnectionManager(ConnectionManager connectionManager) {
//    	this.connectionManager = connectionManager;
//	}

	public TabSetsReader getTabSetsReader() {
		if(null == tabSetsReader){
			tabSetsReader = new TabSetsReader();
		}
		return tabSetsReader;
	}

	public SubMenuReader getSubMenuReader() {
		if(null == subMenuReader){
			subMenuReader = new SubMenuReader();
		}
			
		return subMenuReader;
	}
	
	public SubMenuBuilderFacade getSubMenuBuilder(){
		if (subMenuBuilder == null){
			subMenuBuilder = new SubMenuBuilderFacade();
		}
		return subMenuBuilder;
	}
	
	public XMLValidator getXMLValidator(){
		if (xmlValidator == null){
			xmlValidator = new XMLValidator();
		}
		return xmlValidator;
	}

    public Authentication getAuthentication() {
        return SecurityContextHolder.getContext().getAuthentication();
    }
	
}
